<!DOCTYPE html><html lang="zh-CN" data-theme="light"><head><meta charset="UTF-8"><meta http-equiv="X-UA-Compatible" content="IE=edge"><meta name="viewport" content="width=device-width,initial-scale=1"><title>Shell语言 —— 基础知识 | SeMaik</title><meta name="author" content="ZuSir"><meta name="copyright" content="ZuSir"><meta name="format-detection" content="telephone=no"><meta name="theme-color" content="#ffffff"><meta name="description" content="1、脚本俗称：命令的集合2、管道和重定向： 管道：连接多条命令，前一天命令正确执行的结果，作为后一条命令的输入条件。  重定向：将输出到屏幕中的内容保存放到文件中。   3、交互设备文件：输出、输入、错误  标准输入设备：键盘（stdin），设备描述符“0”  标准输出设备：显示器（stdout），设备描述符“1”  错误输出设备：显示器（stderr），设备描述符“2”   4、覆盖数据和追加数">
<meta property="og:type" content="article">
<meta property="og:title" content="Shell语言 —— 基础知识">
<meta property="og:url" content="http://example.com/2022/02/09/Shell%E8%AF%AD%E8%A8%80-%E2%80%94%E2%80%94-%E5%9F%BA%E7%A1%80%E7%9F%A5%E8%AF%86/index.html">
<meta property="og:site_name" content="SeMaik">
<meta property="og:description" content="1、脚本俗称：命令的集合2、管道和重定向： 管道：连接多条命令，前一天命令正确执行的结果，作为后一条命令的输入条件。  重定向：将输出到屏幕中的内容保存放到文件中。   3、交互设备文件：输出、输入、错误  标准输入设备：键盘（stdin），设备描述符“0”  标准输出设备：显示器（stdout），设备描述符“1”  错误输出设备：显示器（stderr），设备描述符“2”   4、覆盖数据和追加数">
<meta property="og:locale" content="zh_CN">
<meta property="og:image" content="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg">
<meta property="article:published_time" content="2022-02-09T09:13:00.000Z">
<meta property="article:modified_time" content="2022-02-17T03:26:47.182Z">
<meta property="article:author" content="ZuSir">
<meta name="twitter:card" content="summary">
<meta name="twitter:image" content="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg"><link rel="shortcut icon" href="https://myit.icu/favicon.ico"><link rel="canonical" href="http://example.com/2022/02/09/Shell%E8%AF%AD%E8%A8%80-%E2%80%94%E2%80%94-%E5%9F%BA%E7%A1%80%E7%9F%A5%E8%AF%86/"><link rel="preconnect" href="//cdn.jsdelivr.net"/><link rel="preconnect" href="//busuanzi.ibruce.info"/><link rel="stylesheet" href="/css/index.css"><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@fortawesome/fontawesome-free/css/all.min.css" media="print" onload="this.media='all'"><script>const GLOBAL_CONFIG = { 
  root: '/',
  algolia: undefined,
  localSearch: undefined,
  translate: undefined,
  noticeOutdate: undefined,
  highlight: {"plugin":"highlighjs","highlightCopy":true,"highlightLang":true},
  copy: {
    success: '复制成功',
    error: '复制错误',
    noSupport: '浏览器不支持'
  },
  relativeDate: {
    homepage: true,
    post: false
  },
  runtime: '',
  date_suffix: {
    just: '刚刚',
    min: '分钟前',
    hour: '小时前',
    day: '天前',
    month: '个月前'
  },
  copyright: undefined,
  lightbox: 'fancybox',
  Snackbar: undefined,
  source: {
    jQuery: 'https://cdn.jsdelivr.net/npm/jquery@latest/dist/jquery.min.js',
    justifiedGallery: {
      js: 'https://cdn.jsdelivr.net/npm/justifiedGallery/dist/js/jquery.justifiedGallery.min.js',
      css: 'https://cdn.jsdelivr.net/npm/justifiedGallery/dist/css/justifiedGallery.min.css'
    },
    fancybox: {
      js: 'https://cdn.jsdelivr.net/npm/@fancyapps/fancybox@latest/dist/jquery.fancybox.min.js',
      css: 'https://cdn.jsdelivr.net/npm/@fancyapps/fancybox@latest/dist/jquery.fancybox.min.css'
    }
  },
  isPhotoFigcaption: false,
  islazyload: false,
  isanchor: false
}</script><script id="config-diff">var GLOBAL_CONFIG_SITE = { 
  isPost: true,
  isHome: false,
  isHighlightShrink: undefined,
  isToc: true,
  postUpdate: '2022-02-17 11:26:47'
}</script><noscript><style type="text/css">
  #nav {
    opacity: 1
  }
  .justified-gallery img {
    opacity: 1
  }

  #recent-posts time,
  #post-meta time {
    display: inline !important
  }
</style></noscript><script>(win=>{
    win.saveToLocal = {
      set: function setWithExpiry(key, value, ttl) {
        if (ttl === 0) return
        const now = new Date()
        const expiryDay = ttl * 86400000
        const item = {
          value: value,
          expiry: now.getTime() + expiryDay,
        }
        localStorage.setItem(key, JSON.stringify(item))
      },

      get: function getWithExpiry(key) {
        const itemStr = localStorage.getItem(key)

        if (!itemStr) {
          return undefined
        }
        const item = JSON.parse(itemStr)
        const now = new Date()

        if (now.getTime() > item.expiry) {
          localStorage.removeItem(key)
          return undefined
        }
        return item.value
      }
    }
  
    win.getScript = url => new Promise((resolve, reject) => {
      const script = document.createElement('script')
      script.src = url
      script.async = true
      script.onerror = reject
      script.onload = script.onreadystatechange = function() {
        const loadState = this.readyState
        if (loadState && loadState !== 'loaded' && loadState !== 'complete') return
        script.onload = script.onreadystatechange = null
        resolve()
      }
      document.head.appendChild(script)
    })
  
      const asideStatus = saveToLocal.get('aside-status')
      if (asideStatus !== undefined) {
        if (asideStatus === 'hide') {
          document.documentElement.classList.add('hide-aside')
        } else {
          document.documentElement.classList.remove('hide-aside')
        }
      }
    })(window)</script><link href="/css/style.css"><meta name="generator" content="Hexo 5.3.0"><link rel="alternate" href="/atom.xml" title="SeMaik" type="application/atom+xml">
</head><body><div id="web_bg"></div><div id="sidebar"><div id="menu-mask"></div><div id="sidebar-menus"><div class="author-avatar"><img class="avatar-img" src="/img/123.jpeg" onerror="onerror=null;src='/img/123.jpeg'" alt="avatar"/></div><div class="site-data"><div class="data-item is-center"><div class="data-item-link"><a href="/archives/"><div class="headline">文章</div><div class="length-num">152</div></a></div></div><div class="data-item is-center"><div class="data-item-link"><a href="/categories/"><div class="headline">分类</div><div class="length-num">37</div></a></div></div></div><hr/><div class="menus_items"><div class="menus_item"><a class="site-page" href="/"><i class="fa-fw fas fa-home"></i><span> 首页</span></a></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Linux</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Linux/"><span> Linux</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> WEB</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Apache/"><span> Apache</span></a></li><li><a class="site-page" href="/categories/Nginx/"><span> Nginx</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 存储</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ceph/"><span> Ceph</span></a></li><li><a class="site-page" href="/categories/NFS/"><span> NFS</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 日志</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Loki"><span> Loki</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 编程</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Shell"><span> Shell</span></a></li><li><a class="site-page" href="/categories/Python"><span> Python</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 高可用</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/KeepAlived/"><span> KeepAlived</span></a></li><li><a class="site-page" href="/categories/LVS/"><span> LVS</span></a></li><li><a class="site-page" href="/categories/Squid/"><span> Squid</span></a></li><li><a class="site-page" href="/categories/Haproxy/"><span> Haproxy</span></a></li><li><a class="site-page" href="/categories/Rsync/"><span> Rsync</span></a></li><li><a class="site-page" href="/categories/Memcache/"><span> Memcache</span></a></li><li><a class="site-page" href="/categories/Varnish/"><span> Varnish</span></a></li><li><a class="site-page" href="/categories/GRedis/"><span> Redis</span></a></li><li><a class="site-page" href="/categories/Rabbit/"><span> RabbitMQ</span></a></li><li><a class="site-page" href="/categories/Kafka/"><span> Kafka</span></a></li><li><a class="site-page" href="/categories/MHA/"><span> MHA</span></a></li><li><a class="site-page" href="/categories/PXC/"><span> PXC</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 虚拟化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Docker/"><span> Docker</span></a></li><li><a class="site-page" href="/categories/Kubernetes/"><span> Kubernetes</span></a></li><li><a class="site-page" href="/categories/OpenStack/"><span> OpenStack</span></a></li><li><a class="site-page" href="/categories/KVM/"><span> KVM</span></a></li><li><a class="site-page" href="/categories/Containerd"><span> Containerd</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Hexo</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Hexo/"><span> Hexo</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 数据库</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/MySQL/"><span> MySQL</span></a></li><li><a class="site-page" href="/categories/Readis/"><span> Readis</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 微服务</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Tomcat/"><span> Tomcat</span></a></li><li><a class="site-page" href="/categories/Git/"><span> Git</span></a></li><li><a class="site-page" href="/categories/Maven/"><span> Maven</span></a></li><li><a class="site-page" href="/categories/Nexus/"><span> Nexus</span></a></li><li><a class="site-page" href="/categories/Jenkins/"><span> Jenkins</span></a></li><li><a class="site-page" href="/categories/Spring/"><span> Spring</span></a></li><li><a class="site-page" href="/categories/Consul/"><span> Consul</span></a></li><li><a class="site-page" href="/categories/Harbor/"><span> Harbor</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 自动化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ansible/"><span> Ansible</span></a></li><li><a class="site-page" href="/categories/Pssh/"><span> Pssh</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="/link/"><i class="fa-fw fas fa-link"></i><span> 友链</span></a></div><div class="menus_item"><a class="site-page" href="/about/"><i class="fa-fw fas fa-heart"></i><span> 关于</span></a></div></div></div></div><div class="post" id="body-wrap"><header class="post-bg" id="page-header" style="background-image: url('https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg')"><nav id="nav"><span id="blog_name"><a id="site-name" href="/">SeMaik</a></span><div id="menus"><div class="menus_items"><div class="menus_item"><a class="site-page" href="/"><i class="fa-fw fas fa-home"></i><span> 首页</span></a></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Linux</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Linux/"><span> Linux</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> WEB</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Apache/"><span> Apache</span></a></li><li><a class="site-page" href="/categories/Nginx/"><span> Nginx</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 存储</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ceph/"><span> Ceph</span></a></li><li><a class="site-page" href="/categories/NFS/"><span> NFS</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 日志</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Loki"><span> Loki</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 编程</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Shell"><span> Shell</span></a></li><li><a class="site-page" href="/categories/Python"><span> Python</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 高可用</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/KeepAlived/"><span> KeepAlived</span></a></li><li><a class="site-page" href="/categories/LVS/"><span> LVS</span></a></li><li><a class="site-page" href="/categories/Squid/"><span> Squid</span></a></li><li><a class="site-page" href="/categories/Haproxy/"><span> Haproxy</span></a></li><li><a class="site-page" href="/categories/Rsync/"><span> Rsync</span></a></li><li><a class="site-page" href="/categories/Memcache/"><span> Memcache</span></a></li><li><a class="site-page" href="/categories/Varnish/"><span> Varnish</span></a></li><li><a class="site-page" href="/categories/GRedis/"><span> Redis</span></a></li><li><a class="site-page" href="/categories/Rabbit/"><span> RabbitMQ</span></a></li><li><a class="site-page" href="/categories/Kafka/"><span> Kafka</span></a></li><li><a class="site-page" href="/categories/MHA/"><span> MHA</span></a></li><li><a class="site-page" href="/categories/PXC/"><span> PXC</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 虚拟化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Docker/"><span> Docker</span></a></li><li><a class="site-page" href="/categories/Kubernetes/"><span> Kubernetes</span></a></li><li><a class="site-page" href="/categories/OpenStack/"><span> OpenStack</span></a></li><li><a class="site-page" href="/categories/KVM/"><span> KVM</span></a></li><li><a class="site-page" href="/categories/Containerd"><span> Containerd</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Hexo</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Hexo/"><span> Hexo</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 数据库</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/MySQL/"><span> MySQL</span></a></li><li><a class="site-page" href="/categories/Readis/"><span> Readis</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 微服务</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Tomcat/"><span> Tomcat</span></a></li><li><a class="site-page" href="/categories/Git/"><span> Git</span></a></li><li><a class="site-page" href="/categories/Maven/"><span> Maven</span></a></li><li><a class="site-page" href="/categories/Nexus/"><span> Nexus</span></a></li><li><a class="site-page" href="/categories/Jenkins/"><span> Jenkins</span></a></li><li><a class="site-page" href="/categories/Spring/"><span> Spring</span></a></li><li><a class="site-page" href="/categories/Consul/"><span> Consul</span></a></li><li><a class="site-page" href="/categories/Harbor/"><span> Harbor</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 自动化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ansible/"><span> Ansible</span></a></li><li><a class="site-page" href="/categories/Pssh/"><span> Pssh</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="/link/"><i class="fa-fw fas fa-link"></i><span> 友链</span></a></div><div class="menus_item"><a class="site-page" href="/about/"><i class="fa-fw fas fa-heart"></i><span> 关于</span></a></div></div><div id="toggle-menu"><a class="site-page"><i class="fas fa-bars fa-fw"></i></a></div></div></nav><div id="post-info"><h1 class="post-title">Shell语言 —— 基础知识</h1><div id="post-meta"><div class="meta-firstline"><span class="post-meta-date"><i class="far fa-calendar-alt fa-fw post-meta-icon"></i><span class="post-meta-label">发表于</span><time class="post-meta-date-created" datetime="2022-02-09T09:13:00.000Z" title="发表于 2022-02-09 17:13:00">2022-02-09</time><span class="post-meta-separator">|</span><i class="fas fa-history fa-fw post-meta-icon"></i><span class="post-meta-label">更新于</span><time class="post-meta-date-updated" datetime="2022-02-17T03:26:47.182Z" title="更新于 2022-02-17 11:26:47">2022-02-17</time></span><span class="post-meta-categories"><span class="post-meta-separator">|</span><i class="fas fa-inbox fa-fw post-meta-icon"></i><a class="post-meta-categories" href="/categories/Shell/">Shell</a></span></div><div class="meta-secondline"><span class="post-meta-separator">|</span><span class="post-meta-pv-cv"><i class="far fa-eye fa-fw post-meta-icon"></i><span class="post-meta-label">阅读量:</span><span id="busuanzi_value_page_pv"></span></span></div></div></div></header><main class="layout" id="content-inner"><div id="post"><article class="post-content" id="article-container"><h2 id="1、脚本俗称：命令的集合"><a href="#1、脚本俗称：命令的集合" class="headerlink" title="1、脚本俗称：命令的集合"></a>1、脚本俗称：命令的集合</h2><h2 id="2、管道和重定向："><a href="#2、管道和重定向：" class="headerlink" title="2、管道和重定向："></a>2、管道和重定向：</h2><ul>
<li><p>管道：连接多条命令，前一天命令正确执行的结果，作为后一条命令的输入条件。</p>
</li>
<li><p>重定向：将输出到屏幕中的内容保存放到文件中。</p>
</li>
</ul>
<h2 id="3、交互设备文件："><a href="#3、交互设备文件：" class="headerlink" title="3、交互设备文件："></a>3、交互设备文件：</h2><p>输出、输入、错误</p>
<ul>
<li><p>标准输入设备：键盘（stdin），设备描述符“0”</p>
</li>
<li><p>标准输出设备：显示器（stdout），设备描述符“1”</p>
</li>
<li><p>错误输出设备：显示器（stderr），设备描述符“2”</p>
</li>
</ul>
<h2 id="4、覆盖数据和追加数据："><a href="#4、覆盖数据和追加数据：" class="headerlink" title="4、覆盖数据和追加数据："></a>4、覆盖数据和追加数据：</h2><ul>
<li><p>覆盖输出重定向&gt;：后面的数据会覆盖以前的数据。</p>
</li>
<li><p>追加输出重定向&gt;&gt;：后面的数据会追加到以前的数据末尾。</p>
</li>
<li><p>覆盖错误输出重定向2&gt;：后面的数据会覆盖以前的数据。</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line">例：ls  &#x2F;boooooot 2&gt; &#x2F;q.txt    ls 这个booooot这个目录会将报错信息放入q.txt这	个	文件中，因为没有这个booooot这个目录。</span><br></pre></td></tr></table></figure></li>
<li><p>追加错误输出重定向2&gt;&gt;：输出的数据会追加到文件的末尾。</p>
</li>
<li><p>覆盖混合输出重定向&amp;&gt;：混合重定向（标准和错误重定向）将标准输出，错误输出到    同一个文件。</p>
</li>
<li><p>追加混合输出重定向&amp;&gt;&gt;:混合重定向（标准和错误重定向）将标准输出，错误输出到同    一个文件。</p>
</li>
</ul>
<p>Linux所支持的shell（shell壳）</p>
<p>默认的shell是bash（Bourne Again shell）</p>
<h2 id="5、脚本执行的方式："><a href="#5、脚本执行的方式：" class="headerlink" title="5、脚本执行的方式："></a>5、脚本执行的方式：</h2><p>1）路径执行：脚本必须有执行的权限</p>
<p>2）.或者source：脚本可以不具备执行权限（使设置的变量立即生效）</p>
<p>3）Shell程序执行：必须是系统所安装的shell，脚本可以不具备执行权限</p>
<h2 id="6、Shell脚本格式："><a href="#6、Shell脚本格式：" class="headerlink" title="6、Shell脚本格式："></a>6、Shell脚本格式：</h2><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br></pre></td><td class="code"><pre><span class="line">#!&#x2F;bin&#x2F;bash （名：shebang，必须在脚本的第一行，指定脚本的执行程序）</span><br><span class="line">\#注释行信息#（两种方式EOF或END）</span><br><span class="line">jiaoben  &gt;&gt;&gt;EOF</span><br><span class="line">注释行1</span><br><span class="line">注释行2</span><br><span class="line">EOF或END</span><br><span class="line">命令集合</span><br><span class="line"></span><br></pre></td></tr></table></figure>
<p>例：</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br></pre></td><td class="code"><pre><span class="line">#!&#x2F;bin&#x2F;bash</span><br><span class="line">jiaoben  &gt;&gt;&gt;EOF</span><br><span class="line">diyigejiaoben</span><br><span class="line">anzhuanghttpd</span><br><span class="line">EOF</span><br><span class="line"></span><br><span class="line">tar zxvf htppd-</span><br><span class="line">.&#x2F;configure</span><br><span class="line">make</span><br><span class="line">make install</span><br></pre></td></tr></table></figure>
<h2 id="7、变量："><a href="#7、变量：" class="headerlink" title="7、变量："></a>7、变量：</h2><p>1）局部变量：只对当前的shell 生效</p>
<p>2）全局变量：对所有shell都生效 （export  变量名）</p>
<p>3）用户变量：只对某个用户生效，配置文件宿主目录下.bash_profile和.bashrc</p>
<p>4）系统变量：对所有用户都生效，配置文件/etc/profile和/etc/bashrc</p>
<p>5）自定义变量：用户自己定的变量</p>
<p>6）预定义变量：bash中内置的一类变量，不能直接修改</p>
<p>A）预定义变量类型：</p>
<p>​    $#：位置变量个数</p>
<p>$*：位置变量内容</p>
<p>$?：返回上一条命令执行结果状态码（0是正确，1-255代表错误）</p>
<p>$0：命令字</p>
<h2 id="8、特殊的shell变量："><a href="#8、特殊的shell变量：" class="headerlink" title="8、特殊的shell变量："></a>8、特殊的shell变量：</h2><p>1）环境变量</p>
<p>系统执行用户命令时，若用户未给出绝对路径，则首先在当前目录下寻找相应的可执行文件、批处理文件（另外一种可以执行的文件）等。若找不到，再依次在PATH保存的这些路径中寻找相应的可执行的程序文件。系统就以第一次找到的为准。</p>
<p>（举个例子当操作员运行mysql命令：也就是说在一个程序不做环境变量和软链接时，输入这条命令就会提示未找到命令，这个未找到命令就是系统找不到咱们这个程序，这时就用到了咱们这个环境变量或者软链接，做环境变量的意义就是为咱们这个操作系统系统程序的工作路径方便操作系统去寻找程序，这时咱们设置环境变量的时候PATH就要指定该程序的绝对路径，然后再运行程序的时候就可以顺利的进行了）</p>
<p>声明变量：[varname变量名]=[varvalues变量值]</p>
<p>查看变量：echo $varname变量名</p>
<p>转换局部为全局变量：</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br></pre></td><td class="code"><pre><span class="line">1）export a&#x3D;4</span><br><span class="line">2）a&#x3D;4</span><br><span class="line">export</span><br></pre></td></tr></table></figure>
<p>变量赋值的特殊操作之引号</p>
<p>双引“”：可以显示变量</p>
<p>单引‘’：强引用，引用普通字符</p>
<p>反撇号`：引用命令执行结果</p>
<p>read:交互中，提示用户输入信息</p>
<p>\转移符：把一些特殊的字符转化成为自己本身代表的字符，正则表达式中多用。</p>
<h2 id="9、变量赋值的特殊操作："><a href="#9、变量赋值的特殊操作：" class="headerlink" title="9、变量赋值的特殊操作："></a>9、变量赋值的特殊操作：</h2><p>在等号=后边直接指定变量内容时为变量赋值的最基本方法，除此之外，还有一些特殊    的赋值的操作。</p>
<h3 id="1）双引号“”"><a href="#1）双引号“”" class="headerlink" title="1）双引号“”"></a><strong>1）双引号“”</strong></h3><p>如果其定义变量的时候使用双引号的话，则里面的变量或者函数会通过解析，解析完成后再输出内容，而不是把双引号中的变量名以及命令原样子输出。</p>
<p>特别的是当要赋值的内容中包含空格时，必须以引号括起来，其他情况下可以省略。</p>
<figure class="highlight sh"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br></pre></td><td class="code"><pre><span class="line"><span class="comment"># a=zx o</span></span><br><span class="line">bash: o: <span class="built_in">command</span> not found</span><br><span class="line"><span class="comment"># a=&quot;zx o&quot;</span></span><br><span class="line"><span class="comment"># echo $a</span></span><br><span class="line">zx o</span><br></pre></td></tr></table></figure>
<p>这就是在赋值的时候值有空格，执行后报错（加上引号才可以执行）</p>
<figure class="highlight sh"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br></pre></td><td class="code"><pre><span class="line"><span class="comment"># you=&quot;zx&quot;</span></span><br><span class="line"><span class="comment"># echo $you</span></span><br><span class="line">zx</span><br></pre></td></tr></table></figure>
<p>输出变量中的内容时必须加“引号” ””，在引号内使用“$”符号就是引用其他变量的值（变量引用）从而能够直接调用现有变量的值来赋给新的变量，意思就是先将引号中的变量进行解析，成功解析后在用echo命令输出。</p>
<h3 id="2）单引号（’’）："><a href="#2）单引号（’’）：" class="headerlink" title="2）单引号（’’）："></a><strong>2）</strong>单引号（’’）：</h3><p>当要赋值的内容中包含$、”、\ 等具有特殊含义的字符时，应使用单引号括起来，    在单引号的范围内将无法引用其他的变量，任何字符就会作为普通的字符看待，但    是赋值内容包含单引号时需使用 \ 符号进行转义，以免冲突。</p>
<p>意思就是单引号中的值都是会直接输出字符或这字符串的字面量，不会去解析各种变量或者其他的符号，而且必须是成对出现的。</p>
<figure class="highlight sh"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br></pre></td><td class="code"><pre><span class="line"><span class="comment"># b=&#x27;my is $a&#x27;	//这里的$符号不再引用变量</span></span><br><span class="line"><span class="comment"># echo $b</span></span><br><span class="line">my is <span class="variable">$a</span>	//直接输出原样的字符串</span><br></pre></td></tr></table></figure>
<h3 id="3）反撇号（-）：同等与"><a href="#3）反撇号（-）：同等与" class="headerlink" title="3）反撇号（`）：同等与$( )"></a><strong>3）</strong>反撇号（`）：同等与$( )</h3><p>反撇号主要用于命令替换，允许将执行某个命令的屏幕输出结果赋值给变量，反撇号括起来的范围内必须是能够执行的命令行，否则将会出错。</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br></pre></td><td class="code"><pre><span class="line">[root@ansible-server ~]# ls -lh &#96;which useradd&#96;</span><br><span class="line">-rwxr-x---. 1 root root 116K Nov  6  2016 &#x2F;usr&#x2F;sbin&#x2F;useradd</span><br><span class="line">[root@ansible-server ~]# ls -lh $(which useradd)</span><br><span class="line">-rwxr-x---. 1 root root 116K Nov  6  2016 &#x2F;usr&#x2F;sbin&#x2F;useradd</span><br></pre></td></tr></table></figure>
<p>注意：使用反撇号难以在同一行命令中实现嵌套命令替换操作这时就可以用“$( )”来代替反撇号的操作（从里到外依次执行替换）。</p>
<p>例：查看useradd的安装包的文件位置在哪。</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br></pre></td><td class="code"><pre><span class="line">[root@ansible-server ~]# rpm -qc $(rpm -qf &#96;which useradd&#96;)</span><br><span class="line">&#x2F;etc&#x2F;default&#x2F;useradd</span><br><span class="line">&#x2F;etc&#x2F;login.defs</span><br></pre></td></tr></table></figure>
<h3 id="4）read命令："><a href="#4）read命令：" class="headerlink" title="4）read命令："></a>4）read命令：</h3><p>Read命令用来提示用户输入信息，从而实现简单的交互过程。</p>
<p>选项：</p>
<p>-p：指定要显示信息的提示</p>
<p>-s：静默输入，一般用于密码</p>
<p>-n #：指定输入的字符长度最大值#</p>
<p>-d ’字符’：输入结束符，当你输入的内容出现这个字符时，立即结束输入</p>
<p>-t N：超出N秒没有进行输入，则自动退出。    </p>
<p>执行read命令后，进入输数据的时刻输完回车，这时输入后的值成为变量值。</p>
<figure class="highlight sh"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br></pre></td><td class="code"><pre><span class="line">[root@ansible-server ~]<span class="comment"># read zx</span></span><br><span class="line">ni hao</span><br><span class="line">[root@ansible-server ~]<span class="comment"># echo $zx</span></span><br><span class="line">ni hao</span><br></pre></td></tr></table></figure>
<h3 id="5）设置变量的作用范围："><a href="#5）设置变量的作用范围：" class="headerlink" title="5）设置变量的作用范围："></a>5）设置变量的作用范围：</h3><p>默认情况下，新定义的变量只在当前的shell环境中生效，因此称为局部变量，当进入子程序或新的子shell环境中，局部变量无法生效。例：</p>
<figure class="highlight sh"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br><span class="line">11</span><br><span class="line">12</span><br><span class="line">13</span><br><span class="line">14</span><br></pre></td><td class="code"><pre><span class="line">[root@ansible-server ~]<span class="comment"># echo $zx	</span></span><br><span class="line">ni hao	//当前定义的变量值</span><br><span class="line">[root@ansible-server ~]<span class="comment"># bash	//进入子shell环境中</span></span><br><span class="line">[root@ansible-server ~]<span class="comment"># echo $zx	//无法调用父shell环境中的变量</span></span><br><span class="line"></span><br><span class="line">[root@ansible-server ~]<span class="comment"># exit	//返回原来的shell环境中</span></span><br><span class="line"><span class="built_in">exit</span></span><br><span class="line">[root@ansible-server ~]<span class="comment"># export zx	//将当前局部变量设置为全局变量</span></span><br><span class="line">[root@ansible-server ~]<span class="comment"># bash</span></span><br><span class="line">[root@ansible-server ~]<span class="comment"># echo $zx	//进入子shell环境依旧可以调用变量这就是全局变量的效果。</span></span><br><span class="line">ni hao</span><br><span class="line">[root@ansible-server ~]<span class="comment"># exit</span></span><br><span class="line"><span class="built_in">exit</span></span><br><span class="line"></span><br></pre></td></tr></table></figure>
</article><div class="post-copyright"><div class="post-copyright__author"><span class="post-copyright-meta">文章作者: </span><span class="post-copyright-info"><a href="mailto:undefined">ZuSir</a></span></div><div class="post-copyright__type"><span class="post-copyright-meta">文章链接: </span><span class="post-copyright-info"><a href="http://example.com/2022/02/09/Shell%E8%AF%AD%E8%A8%80-%E2%80%94%E2%80%94-%E5%9F%BA%E7%A1%80%E7%9F%A5%E8%AF%86/">http://example.com/2022/02/09/Shell%E8%AF%AD%E8%A8%80-%E2%80%94%E2%80%94-%E5%9F%BA%E7%A1%80%E7%9F%A5%E8%AF%86/</a></span></div><div class="post-copyright__notice"><span class="post-copyright-meta">版权声明: </span><span class="post-copyright-info">本博客所有文章除特别声明外，均采用 <a href="https://creativecommons.org/licenses/by-nc-sa/4.0/" target="_blank">CC BY-NC-SA 4.0</a> 许可协议。转载请注明来自 <a href="http://example.com" target="_blank">SeMaik</a>！</span></div></div><div class="tag_share"><div class="post-meta__tag-list"></div><div class="post_share"><div class="social-share" data-image="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg" data-sites="facebook,twitter,wechat,weibo,qq"></div><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/social-share.js/dist/css/share.min.css" media="print" onload="this.media='all'"><script src="https://cdn.jsdelivr.net/npm/social-share.js/dist/js/social-share.min.js" defer></script></div></div><nav class="pagination-post" id="pagination"><div class="prev-post pull-left"><a href="/2022/02/09/Shell%E8%AF%AD%E8%A8%80-%E2%80%94%E2%80%94-IF%E6%9D%A1%E4%BB%B6%E5%88%A4%E6%96%AD/"><img class="prev-cover" src="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg" onerror="onerror=null;src='/img/123.jpeg'" alt="cover of previous post"><div class="pagination-info"><div class="label">上一篇</div><div class="prev_info">Shell语言 —— IF条件判断</div></div></a></div><div class="next-post pull-right"><a href="/2022/01/07/Centos%E4%BF%AE%E6%94%B9%E7%BD%91%E5%8D%A1%E5%90%8D%E7%A7%B0/"><img class="next-cover" src="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg" onerror="onerror=null;src='/img/123.jpeg'" alt="cover of next post"><div class="pagination-info"><div class="label">下一篇</div><div class="next_info">Centos修改网卡名称</div></div></a></div></nav></div><div class="aside-content" id="aside-content"><div class="card-widget card-info"><div class="card-info-avatar is-center"><img class="avatar-img" src="/img/123.jpeg" onerror="this.onerror=null;this.src='/img/123.jpeg'" alt="avatar"/><div class="author-info__name">ZuSir</div><div class="author-info__description">一个收藏回忆与分享技术的地方!</div></div><div class="card-info-data"><div class="card-info-data-item is-center"><a href="/archives/"><div class="headline">文章</div><div class="length-num">152</div></a></div><div class="card-info-data-item is-center"><a href="/categories/"><div class="headline">分类</div><div class="length-num">37</div></a></div></div></div><div class="card-widget card-announcement"><div class="item-headline"><i class="fas fa-bullhorn card-announcement-animation"></i><span>公告</span></div><div class="announcement_content">This is my Blog! <img src="https://ss0.bdstatic.com/70cFuHSh_Q1YnxGkpoWK1HF6hhy/it/u=3894415926,2787041726&fm=26&gp=0.jpg"></div></div><div class="sticky_layout"><div class="card-widget" id="card-toc"><div class="item-headline"><i class="fas fa-stream"></i><span>目录</span></div><div class="toc-content"><ol class="toc"><li class="toc-item toc-level-2"><a class="toc-link" href="#1%E3%80%81%E8%84%9A%E6%9C%AC%E4%BF%97%E7%A7%B0%EF%BC%9A%E5%91%BD%E4%BB%A4%E7%9A%84%E9%9B%86%E5%90%88"><span class="toc-number">1.</span> <span class="toc-text">1、脚本俗称：命令的集合</span></a></li><li class="toc-item toc-level-2"><a class="toc-link" href="#2%E3%80%81%E7%AE%A1%E9%81%93%E5%92%8C%E9%87%8D%E5%AE%9A%E5%90%91%EF%BC%9A"><span class="toc-number">2.</span> <span class="toc-text">2、管道和重定向：</span></a></li><li class="toc-item toc-level-2"><a class="toc-link" href="#3%E3%80%81%E4%BA%A4%E4%BA%92%E8%AE%BE%E5%A4%87%E6%96%87%E4%BB%B6%EF%BC%9A"><span class="toc-number">3.</span> <span class="toc-text">3、交互设备文件：</span></a></li><li class="toc-item toc-level-2"><a class="toc-link" href="#4%E3%80%81%E8%A6%86%E7%9B%96%E6%95%B0%E6%8D%AE%E5%92%8C%E8%BF%BD%E5%8A%A0%E6%95%B0%E6%8D%AE%EF%BC%9A"><span class="toc-number">4.</span> <span class="toc-text">4、覆盖数据和追加数据：</span></a></li><li class="toc-item toc-level-2"><a class="toc-link" href="#5%E3%80%81%E8%84%9A%E6%9C%AC%E6%89%A7%E8%A1%8C%E7%9A%84%E6%96%B9%E5%BC%8F%EF%BC%9A"><span class="toc-number">5.</span> <span class="toc-text">5、脚本执行的方式：</span></a></li><li class="toc-item toc-level-2"><a class="toc-link" href="#6%E3%80%81Shell%E8%84%9A%E6%9C%AC%E6%A0%BC%E5%BC%8F%EF%BC%9A"><span class="toc-number">6.</span> <span class="toc-text">6、Shell脚本格式：</span></a></li><li class="toc-item toc-level-2"><a class="toc-link" href="#7%E3%80%81%E5%8F%98%E9%87%8F%EF%BC%9A"><span class="toc-number">7.</span> <span class="toc-text">7、变量：</span></a></li><li class="toc-item toc-level-2"><a class="toc-link" href="#8%E3%80%81%E7%89%B9%E6%AE%8A%E7%9A%84shell%E5%8F%98%E9%87%8F%EF%BC%9A"><span class="toc-number">8.</span> <span class="toc-text">8、特殊的shell变量：</span></a></li><li class="toc-item toc-level-2"><a class="toc-link" href="#9%E3%80%81%E5%8F%98%E9%87%8F%E8%B5%8B%E5%80%BC%E7%9A%84%E7%89%B9%E6%AE%8A%E6%93%8D%E4%BD%9C%EF%BC%9A"><span class="toc-number">9.</span> <span class="toc-text">9、变量赋值的特殊操作：</span></a><ol class="toc-child"><li class="toc-item toc-level-3"><a class="toc-link" href="#1%EF%BC%89%E5%8F%8C%E5%BC%95%E5%8F%B7%E2%80%9C%E2%80%9D"><span class="toc-number">9.1.</span> <span class="toc-text">1）双引号“”</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#2%EF%BC%89%E5%8D%95%E5%BC%95%E5%8F%B7%EF%BC%88%E2%80%99%E2%80%99%EF%BC%89%EF%BC%9A"><span class="toc-number">9.2.</span> <span class="toc-text">2）单引号（’’）：</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#3%EF%BC%89%E5%8F%8D%E6%92%87%E5%8F%B7%EF%BC%88-%EF%BC%89%EF%BC%9A%E5%90%8C%E7%AD%89%E4%B8%8E"><span class="toc-number">9.3.</span> <span class="toc-text">3）反撇号（&#96;）：同等与$( )</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#4%EF%BC%89read%E5%91%BD%E4%BB%A4%EF%BC%9A"><span class="toc-number">9.4.</span> <span class="toc-text">4）read命令：</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#5%EF%BC%89%E8%AE%BE%E7%BD%AE%E5%8F%98%E9%87%8F%E7%9A%84%E4%BD%9C%E7%94%A8%E8%8C%83%E5%9B%B4%EF%BC%9A"><span class="toc-number">9.5.</span> <span class="toc-text">5）设置变量的作用范围：</span></a></li></ol></li></ol></div></div><div class="card-widget card-recent-post"><div class="item-headline"><i class="fas fa-history"></i><span>最新文章</span></div><div class="aside-list"><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E9%83%A8%E7%BD%B2Zabbix-Server5-0/" title="Shell程序——部署Zabbix-ServerV5.0">Shell程序——部署Zabbix-ServerV5.0</a><time datetime="2022-02-17T03:32:00.000Z" title="发表于 2022-02-17 11:32:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E9%83%A8%E7%BD%B2Harbor/" title="Shell程序——部署Harbor">Shell程序——部署Harbor</a><time datetime="2022-02-17T03:31:00.000Z" title="发表于 2022-02-17 11:31:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94Mysql%E5%A4%87%E4%BB%BD/" title="Shell程序——Mysql备份">Shell程序——Mysql备份</a><time datetime="2022-02-17T03:30:00.000Z" title="发表于 2022-02-17 11:30:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E6%89%B9%E9%87%8F%E4%BF%9D%E5%AD%98Docker-image/" title="Shell程序——批量保存Docker_image">Shell程序——批量保存Docker_image</a><time datetime="2022-02-17T03:29:00.000Z" title="发表于 2022-02-17 11:29:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E5%85%A8%E6%AE%B5IP%E6%89%AB%E6%8F%8F/" title="Shell程序——全段IP扫描">Shell程序——全段IP扫描</a><time datetime="2022-02-17T03:28:00.000Z" title="发表于 2022-02-17 11:28:00">2022-02-17</time></div></div></div></div></div></div></main><footer id="footer"><div id="footer-wrap"><div class="copyright">&copy;2020 - 2022 By ZuSir</div><div class="framework-info"><span>框架 </span><a target="_blank" rel="noopener" href="https://hexo.io">Hexo</a><span class="footer-separator">|</span><span>主题 </span><a target="_blank" rel="noopener" href="https://github.com/jerryc127/hexo-theme-butterfly">Butterfly</a></div></div></footer></div><div id="rightside"><div id="rightside-config-hide"><button id="readmode" type="button" title="阅读模式"><i class="fas fa-book-open"></i></button><button id="hide-aside-btn" type="button" title="单栏和双栏切换"><i class="fas fa-arrows-alt-h"></i></button></div><div id="rightside-config-show"><button id="rightside_config" type="button" title="设置"><i class="fas fa-cog fa-spin"></i></button><button class="close" id="mobile-toc-button" type="button" title="目录"><i class="fas fa-list-ul"></i></button><button id="go-up" type="button" title="回到顶部"><i class="fas fa-arrow-up"></i></button></div></div><div><script src="/js/utils.js"></script><script src="/js/main.js"></script><div class="js-pjax"></div><script defer="defer" id="fluttering_ribbon" mobile="true" src="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/dist/canvas-fluttering-ribbon.min.js"></script><script async data-pjax src="//busuanzi.ibruce.info/busuanzi/2.3/busuanzi.pure.mini.js"></script></div></body></html>